/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 496
#ifdef HAVE_CONFIG_H
#line 496
# include <config.h>
#line 496
#endif
#line 496
#include <sys/types.h>
#line 496

#line 496
#include "mailfromd.h"
#line 496
#include "prog.h"
#line 496
#include "builtin.h"
#line 496

#line 496

#line 660 "../../src/builtin/snarf.m4"

#line 1 "msg.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"

static size_t nmsgs = NMSGS;

static struct mu_cfg_param msg_cfg_param[] = {
	{ "max-open-messages", mu_cfg_size, &nmsgs, 0, NULL,
	  N_("Maximum number of messages to open simultaneously.") },
	{ NULL }
};

static void *
alloc_msgs()
{
	return xcalloc(nmsgs, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + nmsgs; p++) {
		bi_close_message(p);
	}
	free(mtab);
}

void
drop_current_message(void *data)
{
	int i;
	struct mf_message *tab = data;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].current) {
			bi_close_message(&tab[i]);
			break;
		}
}


#line 56

#line 56
static int MSGTAB_id;
#line 56 "msg.bi"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		mu_stream_destroy(&mp->mstr);
		mu_stream_destroy(&mp->bstr);
		if (mp->mylist) {
			mu_list_remove(mp->mylist, mp);
			mu_list_destroy(&mp->mylist);
		}
		mu_list_do(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int current)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->current = current;
		mu_list_create(&mp->mylist);
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].current)
			return i;
	return -1;
}


#line 133


#line 144


#line 155


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 160
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 160
	struct mf_message *mp;
#line 160
			
#line 160
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 160
			env_throw_bi(env, mfe_range, NULL, _("invalid message descriptor"))
#line 160
;
#line 160
	mp = mtab + nmsg;
#line 160
		if (!(mp->msg))
#line 160
			env_throw_bi(env, mfe_failure, NULL, _("message not open"))
#line 160

#line 160
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 165
bi_message_close(eval_environ_t env)
#line 165

#line 165 "msg.bi"
{
#line 165
	
#line 165

#line 165

#line 165
long  nmsg;
#line 165
        
#line 165
get_numeric_arg(env, 0, &nmsg);
#line 165
        
#line 165

#line 165
        adjust_stack(env, 1);
#line 165

#line 165
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 165
		prog_trace(env, "message_close %lu",nmsg);;
#line 165

{
	
#line 167
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 167
	struct mf_message *mp;
#line 167
			
#line 167
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 167
			env_throw_bi(env, mfe_range, "message_close", _("invalid message descriptor"))
#line 167
;
#line 167
	mp = mtab + nmsg;
#line 167
		if (!(mp->msg))
#line 167
			env_throw_bi(env, mfe_failure, "message_close", _("message not open"))
#line 167

#line 167
;
	bi_close_message(mp);
}
}

/* number message_size(number nmsg) */
void
#line 173
bi_message_size(eval_environ_t env)
#line 173

#line 173 "msg.bi"
{
#line 173
	
#line 173

#line 173

#line 173
long  nmsg;
#line 173
        
#line 173
get_numeric_arg(env, 0, &nmsg);
#line 173
        
#line 173

#line 173
        adjust_stack(env, 1);
#line 173

#line 173
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 173
		prog_trace(env, "message_size %lu",nmsg);;
#line 173

{
	int rc;
	size_t size;
	
#line 177
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 177
	struct mf_message *mp;
#line 177
			
#line 177
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 177
			env_throw_bi(env, mfe_range, "message_size", _("invalid message descriptor"))
#line 177
;
#line 177
	mp = mtab + nmsg;
#line 177
		if (!(mp->msg))
#line 177
			env_throw_bi(env, mfe_failure, "message_size", _("message not open"))
#line 177

#line 177
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 180
			env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 182
;
		if (!(size < LONG_MAX))
#line 183
			env_throw_bi(env, mfe_range, "message_size", _("message size out of representable range"))
#line 185
;
	
#line 186
do {
#line 186
  push(env, (STKVAL) ((long)size));
#line 186
  return;
#line 186
} while (0);
}	
}

/* number message_lines(number nmsg) */
void
#line 191
bi_message_lines(eval_environ_t env)
#line 191

#line 191 "msg.bi"
{
#line 191
	
#line 191

#line 191

#line 191
long  nmsg;
#line 191
        
#line 191
get_numeric_arg(env, 0, &nmsg);
#line 191
        
#line 191

#line 191
        adjust_stack(env, 1);
#line 191

#line 191
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 191
		prog_trace(env, "message_lines %lu",nmsg);;
#line 191

{
	int rc;
	size_t lines;
	
#line 195
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 195
	struct mf_message *mp;
#line 195
			
#line 195
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 195
			env_throw_bi(env, mfe_range, "message_lines", _("invalid message descriptor"))
#line 195
;
#line 195
	mp = mtab + nmsg;
#line 195
		if (!(mp->msg))
#line 195
			env_throw_bi(env, mfe_failure, "message_lines", _("message not open"))
#line 195

#line 195
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 198
			env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 201
;
	
#line 202
do {
#line 202
  push(env, (STKVAL) (lines));
#line 202
  return;
#line 202
} while (0);
}
}

/* number message_body_size(number nmsg) */
void
#line 207
bi_message_body_size(eval_environ_t env)
#line 207

#line 207 "msg.bi"
{
#line 207
	
#line 207

#line 207

#line 207
long  nmsg;
#line 207
        
#line 207
get_numeric_arg(env, 0, &nmsg);
#line 207
        
#line 207

#line 207
        adjust_stack(env, 1);
#line 207

#line 207
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 207
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 207

{
	int rc;
	size_t size;
	
#line 211
	
#line 211
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 211
	struct mf_message *mp;
#line 211
			
#line 211
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 211
			env_throw_bi(env, mfe_range, "message_body_size", _("invalid message descriptor"))
#line 211
;
#line 211
	mp = mtab + nmsg;
#line 211
		if (!(mp->msg))
#line 211
			env_throw_bi(env, mfe_failure, "message_body_size", _("message not open"))
#line 211

#line 211
;
#line 211
	if (!mp->body) {
#line 211
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 211
			if (!(rc == 0))
#line 211
			env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 211
;
#line 211
	}	  
#line 211
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 214
			env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 216
;
		if (!(size < LONG_MAX))
#line 217
			env_throw_bi(env, mfe_range, "message_body_size", _("body size out of representable range"))
#line 219
;
	
#line 220
do {
#line 220
  push(env, (STKVAL) ((long)size));
#line 220
  return;
#line 220
} while (0);
}
}

/* number message_body_lines(number nmsg) */
void
#line 225
bi_message_body_lines(eval_environ_t env)
#line 225

#line 225 "msg.bi"
{
#line 225
	
#line 225

#line 225

#line 225
long  nmsg;
#line 225
        
#line 225
get_numeric_arg(env, 0, &nmsg);
#line 225
        
#line 225

#line 225
        adjust_stack(env, 1);
#line 225

#line 225
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 225
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 225

{
	int rc;
	size_t lines;
	
#line 229
	
#line 229
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 229
	struct mf_message *mp;
#line 229
			
#line 229
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 229
			env_throw_bi(env, mfe_range, "message_body_lines", _("invalid message descriptor"))
#line 229
;
#line 229
	mp = mtab + nmsg;
#line 229
		if (!(mp->msg))
#line 229
			env_throw_bi(env, mfe_failure, "message_body_lines", _("message not open"))
#line 229

#line 229
;
#line 229
	if (!mp->body) {
#line 229
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 229
			if (!(rc == 0))
#line 229
			env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 229
;
#line 229
	}	  
#line 229
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 232
			env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 235
;
	
#line 236
do {
#line 236
  push(env, (STKVAL) (lines));
#line 236
  return;
#line 236
} while (0);
}
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 244
bi_message_header_size(eval_environ_t env)
#line 244

#line 244 "msg.bi"
{
#line 244
	
#line 244

#line 244

#line 244
long  nmsg;
#line 244
        
#line 244
get_numeric_arg(env, 0, &nmsg);
#line 244
        
#line 244

#line 244
        adjust_stack(env, 1);
#line 244

#line 244
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 244
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 244

{
	int rc;
	size_t size;
	
#line 248
	
#line 248
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 248
	struct mf_message *mp;
#line 248
			
#line 248
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 248
			env_throw_bi(env, mfe_range, "message_header_size", _("invalid message descriptor"))
#line 248
;
#line 248
	mp = mtab + nmsg;
#line 248
		if (!(mp->msg))
#line 248
			env_throw_bi(env, mfe_failure, "message_header_size", _("message not open"))
#line 248

#line 248
;
#line 248
	if (!mp->hdr) {
#line 248
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 248
			if (!(rc == 0))
#line 248
			env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 248
;
#line 248
	}	  
#line 248
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 251
			env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 253
;
		if (!(size < LONG_MAX))
#line 254
			env_throw_bi(env, mfe_range, "message_header_size", _("header size out of representable range"))
#line 256
;
	
#line 257
do {
#line 257
  push(env, (STKVAL) ((long)size));
#line 257
  return;
#line 257
} while (0);
}
}

/* number message_header_lines(number nmsg) */
void
#line 262
bi_message_header_lines(eval_environ_t env)
#line 262

#line 262 "msg.bi"
{
#line 262
	
#line 262

#line 262

#line 262
long  nmsg;
#line 262
        
#line 262
get_numeric_arg(env, 0, &nmsg);
#line 262
        
#line 262

#line 262
        adjust_stack(env, 1);
#line 262

#line 262
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 262
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 262

{
	int rc;
	size_t lines;
	
#line 266
	
#line 266
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 266
	struct mf_message *mp;
#line 266
			
#line 266
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 266
			env_throw_bi(env, mfe_range, "message_header_lines", _("invalid message descriptor"))
#line 266
;
#line 266
	mp = mtab + nmsg;
#line 266
		if (!(mp->msg))
#line 266
			env_throw_bi(env, mfe_failure, "message_header_lines", _("message not open"))
#line 266

#line 266
;
#line 266
	if (!mp->hdr) {
#line 266
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 266
			if (!(rc == 0))
#line 266
			env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 266
;
#line 266
	}	  
#line 266
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 269
			env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 272
;
	
#line 273
do {
#line 273
  push(env, (STKVAL) (lines));
#line 273
  return;
#line 273
} while (0);
}
}

/* number message_header_count(number nmsg[; string name]) */
void
#line 278
bi_message_header_count(eval_environ_t env)
#line 278

#line 278 "msg.bi"
{
#line 278
	
#line 278

#line 278
long __bi_argcnt;
#line 278
long  nmsg;
#line 278
        char * name;
#line 278
        
#line 278
get_numeric_arg(env, 1, &nmsg);
#line 278
        get_string_arg(env, 2, &name);
#line 278
        
#line 278
get_numeric_arg(env, 0, &__bi_argcnt);
#line 278
        adjust_stack(env, __bi_argcnt + 1);
#line 278

#line 278
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 278
		prog_trace(env, "message_header_count %lu %s",nmsg, ((__bi_argcnt > 1) ? name : ""));;

{
	int rc;
	size_t count;
	
#line 283
	
#line 283
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 283
	struct mf_message *mp;
#line 283
			
#line 283
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 283
			env_throw_bi(env, mfe_range, "message_header_count", _("invalid message descriptor"))
#line 283
;
#line 283
	mp = mtab + nmsg;
#line 283
		if (!(mp->msg))
#line 283
			env_throw_bi(env, mfe_failure, "message_header_count", _("message not open"))
#line 283

#line 283
;
#line 283
	if (!mp->hdr) {
#line 283
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 283
			if (!(rc == 0))
#line 283
			env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 283
;
#line 283
	}	  
#line 283
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 286
			env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 289
;
	
	if ((__bi_argcnt > 1)) {
		size_t n;

		for (n = 1; n <= count; n++) {
			const char *val;
			rc = mu_header_sget_value_n(mp->hdr, name, n, &val);
			if (rc == MU_ERR_NOENT)
				break;
			else if (rc)
					env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc));
		}
		count = n - 1;
	}
	
#line 304
do {
#line 304
  push(env, (STKVAL) (count));
#line 304
  return;
#line 304
} while (0);
}
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 309
bi_message_has_header(eval_environ_t env)
#line 309

#line 309 "msg.bi"
{
#line 309
	
#line 309

#line 309
long __bi_argcnt;
#line 309
long  nmsg;
#line 309
        char * header;
#line 309
        long  idx;
#line 309
        
#line 309
get_numeric_arg(env, 1, &nmsg);
#line 309
        get_string_arg(env, 2, &header);
#line 309
        get_numeric_arg(env, 3, &idx);
#line 309
        
#line 309
get_numeric_arg(env, 0, &__bi_argcnt);
#line 309
        adjust_stack(env, __bi_argcnt + 1);
#line 309

#line 309
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 309
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 314
	
#line 314
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 314
	struct mf_message *mp;
#line 314
			
#line 314
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 314
			env_throw_bi(env, mfe_range, "message_has_header", _("invalid message descriptor"))
#line 314
;
#line 314
	mp = mtab + nmsg;
#line 314
		if (!(mp->msg))
#line 314
			env_throw_bi(env, mfe_failure, "message_has_header", _("message not open"))
#line 314

#line 314
;
#line 314
	if (!mp->hdr) {
#line 314
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 314
			if (!(rc == 0))
#line 314
			env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 314
;
#line 314
	}	  
#line 314
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 317
do {
#line 317
  push(env, (STKVAL) (rc == 0));
#line 317
  return;
#line 317
} while (0);
}
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 322
bi_message_find_header(eval_environ_t env)
#line 322

#line 322 "msg.bi"
{
#line 322
	
#line 322

#line 322
long __bi_argcnt;
#line 322
long  nmsg;
#line 322
        char * header;
#line 322
        long  idx;
#line 322
        
#line 322
get_numeric_arg(env, 1, &nmsg);
#line 322
        get_string_arg(env, 2, &header);
#line 322
        get_numeric_arg(env, 3, &idx);
#line 322
        
#line 322
get_numeric_arg(env, 0, &__bi_argcnt);
#line 322
        adjust_stack(env, __bi_argcnt + 1);
#line 322

#line 322
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 322
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 327
	
#line 327
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 327
	struct mf_message *mp;
#line 327
			
#line 327
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 327
			env_throw_bi(env, mfe_range, "message_find_header", _("invalid message descriptor"))
#line 327
;
#line 327
	mp = mtab + nmsg;
#line 327
		if (!(mp->msg))
#line 327
			env_throw_bi(env, mfe_failure, "message_find_header", _("message not open"))
#line 327

#line 327
;
#line 327
	if (!mp->hdr) {
#line 327
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 327
			if (!(rc == 0))
#line 327
			env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 327
;
#line 327
	}	  
#line 327
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_not_found, "message_find_header", _("header not found"));
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 334
return;
#line 334
} while (0);
}
}

/* string message_nth_header_name(number msg, number n) */
void
#line 339
bi_message_nth_header_name(eval_environ_t env)
#line 339

#line 339 "msg.bi"
{
#line 339
	
#line 339

#line 339

#line 339
long  nmsg;
#line 339
        long  idx;
#line 339
        
#line 339
get_numeric_arg(env, 0, &nmsg);
#line 339
        get_numeric_arg(env, 1, &idx);
#line 339
        
#line 339

#line 339
        adjust_stack(env, 2);
#line 339

#line 339
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 339
		prog_trace(env, "message_nth_header_name %lu %lu",nmsg, idx);;
#line 339

{
	int rc;
	const char *val;
	
#line 343
	
#line 343
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 343
	struct mf_message *mp;
#line 343
			
#line 343
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 343
			env_throw_bi(env, mfe_range, "message_nth_header_name", _("invalid message descriptor"))
#line 343
;
#line 343
	mp = mtab + nmsg;
#line 343
		if (!(mp->msg))
#line 343
			env_throw_bi(env, mfe_failure, "message_nth_header_name", _("message not open"))
#line 343

#line 343
;
#line 343
	if (!mp->hdr) {
#line 343
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 343
			if (!(rc == 0))
#line 343
			env_throw_bi(env, mfe_failure, "message_nth_header_name", "mu_message_get_header: %s",mu_strerror(rc))
#line 343
;
#line 343
	}	  
#line 343
;
	
	rc = mu_header_sget_field_name(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_range, "message_nth_header_name", "header index out of range");
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_nth_header_name", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 350
return;
#line 350
} while (0);
}
}

/* string message_nth_header_value(number msg, number n) */
void
#line 355
bi_message_nth_header_value(eval_environ_t env)
#line 355

#line 355 "msg.bi"
{
#line 355
	
#line 355

#line 355

#line 355
long  nmsg;
#line 355
        long  idx;
#line 355
        
#line 355
get_numeric_arg(env, 0, &nmsg);
#line 355
        get_numeric_arg(env, 1, &idx);
#line 355
        
#line 355

#line 355
        adjust_stack(env, 2);
#line 355

#line 355
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 355
		prog_trace(env, "message_nth_header_value %lu %lu",nmsg, idx);;
#line 355

{
	int rc;
	const char *val;
	
#line 359
	
#line 359
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 359
	struct mf_message *mp;
#line 359
			
#line 359
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 359
			env_throw_bi(env, mfe_range, "message_nth_header_value", _("invalid message descriptor"))
#line 359
;
#line 359
	mp = mtab + nmsg;
#line 359
		if (!(mp->msg))
#line 359
			env_throw_bi(env, mfe_failure, "message_nth_header_value", _("message not open"))
#line 359

#line 359
;
#line 359
	if (!mp->hdr) {
#line 359
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 359
			if (!(rc == 0))
#line 359
			env_throw_bi(env, mfe_failure, "message_nth_header_value", "mu_message_get_header: %s",mu_strerror(rc))
#line 359
;
#line 359
	}	  
#line 359
;
	
	rc = mu_header_sget_field_value(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
			env_throw_bi(env, mfe_range, "message_nth_header_value", "header index out of range");
	else if (rc)
			env_throw_bi(env, mfe_failure, "message_nth_header_value", "%s",mu_strerror(rc));
	do {pushs(env, val);
#line 366
return;
#line 366
} while (0);
}
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 374
bi_message_is_multipart(eval_environ_t env)
#line 374

#line 374 "msg.bi"
{
#line 374
	
#line 374

#line 374

#line 374
long  nmsg;
#line 374
        
#line 374
get_numeric_arg(env, 0, &nmsg);
#line 374
        
#line 374

#line 374
        adjust_stack(env, 1);
#line 374

#line 374
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 374
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 374

{
	int rc, res;
	
#line 377
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 377
	struct mf_message *mp;
#line 377
			
#line 377
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 377
			env_throw_bi(env, mfe_range, "message_is_multipart", _("invalid message descriptor"))
#line 377
;
#line 377
	mp = mtab + nmsg;
#line 377
		if (!(mp->msg))
#line 377
			env_throw_bi(env, mfe_failure, "message_is_multipart", _("message not open"))
#line 377

#line 377
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 380
			env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 383
;
	
#line 384
do {
#line 384
  push(env, (STKVAL) (res));
#line 384
  return;
#line 384
} while (0);
}
}

/* number message_count_parts(number msg) */
void
#line 389
bi_message_count_parts(eval_environ_t env)
#line 389

#line 389 "msg.bi"
{
#line 389
	
#line 389

#line 389

#line 389
long  nmsg;
#line 389
        
#line 389
get_numeric_arg(env, 0, &nmsg);
#line 389
        
#line 389

#line 389
        adjust_stack(env, 1);
#line 389

#line 389
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 389
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 389

{
	int rc;
	size_t count;
	
#line 393
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 393
	struct mf_message *mp;
#line 393
			
#line 393
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 393
			env_throw_bi(env, mfe_range, "message_count_parts", _("invalid message descriptor"))
#line 393
;
#line 393
	mp = mtab + nmsg;
#line 393
		if (!(mp->msg))
#line 393
			env_throw_bi(env, mfe_failure, "message_count_parts", _("message not open"))
#line 393

#line 393
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 395
			env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 398
;
	
#line 399
do {
#line 399
  push(env, (STKVAL) (count));
#line 399
  return;
#line 399
} while (0);
}
}

/* number message_get_part(number msg, number idx) */
void
#line 404
bi_message_get_part(eval_environ_t env)
#line 404

#line 404 "msg.bi"
{
#line 404
	
#line 404

#line 404

#line 404
long  nmsg;
#line 404
        long  idx;
#line 404
        
#line 404
get_numeric_arg(env, 0, &nmsg);
#line 404
        get_numeric_arg(env, 1, &idx);
#line 404
        
#line 404

#line 404
        adjust_stack(env, 2);
#line 404

#line 404
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 404
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 404

{
	int rc;
	mu_message_t msg;
	
#line 408
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 408
	struct mf_message *mp;
#line 408
			
#line 408
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 408
			env_throw_bi(env, mfe_range, "message_get_part", _("invalid message descriptor"))
#line 408
;
#line 408
	mp = mtab + nmsg;
#line 408
		if (!(mp->msg))
#line 408
			env_throw_bi(env, mfe_failure, "message_get_part", _("message not open"))
#line 408

#line 408
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 411
			env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 414
;
	rc = bi_message_register(env, mp->msglist, msg, 0);
		if (!(rc >= 0))
#line 416
			env_throw_bi(env, mfe_failure, "message_get_part", _("no more message slots available"))
#line 418
;
	
#line 419
do {
#line 419
  push(env, (STKVAL) (rc));
#line 419
  return;
#line 419
} while (0);
}
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 427
bi_message_rewind(eval_environ_t env)
#line 427

#line 427 "msg.bi"
{
#line 427
	
#line 427

#line 427

#line 427
long  nmsg;
#line 427
        
#line 427
get_numeric_arg(env, 0, &nmsg);
#line 427
        
#line 427

#line 427
        adjust_stack(env, 1);
#line 427

#line 427
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 427
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 427

{
	
#line 429
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 429
	struct mf_message *mp;
#line 429
			
#line 429
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 429
			env_throw_bi(env, mfe_range, "message_rewind", _("invalid message descriptor"))
#line 429
;
#line 429
	mp = mtab + nmsg;
#line 429
		if (!(mp->msg))
#line 429
			env_throw_bi(env, mfe_failure, "message_rewind", _("message not open"))
#line 429

#line 429
;
	mu_stream_destroy(&mp->mstr);
}
}

/* string message_read_line(number nmsg) */
void
#line 435
bi_message_read_line(eval_environ_t env)
#line 435

#line 435 "msg.bi"
{
#line 435
	
#line 435

#line 435

#line 435
long  nmsg;
#line 435
        
#line 435
get_numeric_arg(env, 0, &nmsg);
#line 435
        
#line 435

#line 435
        adjust_stack(env, 1);
#line 435

#line 435
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 435
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 435

{
	int rc;
	size_t size;
	
#line 439
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 439
	struct mf_message *mp;
#line 439
			
#line 439
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 439
			env_throw_bi(env, mfe_range, "message_read_line", _("invalid message descriptor"))
#line 439
;
#line 439
	mp = mtab + nmsg;
#line 439
		if (!(mp->msg))
#line 439
			env_throw_bi(env, mfe_failure, "message_read_line", _("message not open"))
#line 439

#line 439
;

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 443
			env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 446
;
	}
	rc = mu_stream_getline(mp->mstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 449
			env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 452
;
		if (!(size > 0))
#line 453
			env_throw_bi(env, mfe_eof, "message_read_line", "mu_stream_getline: %s",_("end of input"))
#line 456
;
	do {pushs(env, mp->buf);
#line 457
return;
#line 457
} while (0);
}
}

/* string message_body_rewind(number nmsg) */
void
#line 462
bi_message_body_rewind(eval_environ_t env)
#line 462

#line 462 "msg.bi"
{
#line 462
	
#line 462

#line 462

#line 462
long  nmsg;
#line 462
        
#line 462
get_numeric_arg(env, 0, &nmsg);
#line 462
        
#line 462

#line 462
        adjust_stack(env, 1);
#line 462

#line 462
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 462
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 462

{
	
#line 464
	
#line 464
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 464
	struct mf_message *mp;
#line 464
			
#line 464
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 464
			env_throw_bi(env, mfe_range, "message_body_rewind", _("invalid message descriptor"))
#line 464
;
#line 464
	mp = mtab + nmsg;
#line 464
		if (!(mp->msg))
#line 464
			env_throw_bi(env, mfe_failure, "message_body_rewind", _("message not open"))
#line 464

#line 464
;
#line 464
	if (!mp->body) {
#line 464
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 464
			if (!(rc == 0))
#line 464
			env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 464
;
#line 464
	}	  
#line 464
;
	mu_stream_destroy(&mp->bstr);
}
}

/* string message_read_body_line(number msg)  */
void
#line 470
bi_message_read_body_line(eval_environ_t env)
#line 470

#line 470 "msg.bi"
{
#line 470
	
#line 470

#line 470

#line 470
long  nmsg;
#line 470
        
#line 470
get_numeric_arg(env, 0, &nmsg);
#line 470
        
#line 470

#line 470
        adjust_stack(env, 1);
#line 470

#line 470
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 470
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 470

{
	int rc;
	size_t size;
	
#line 474
	
#line 474
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 474
	struct mf_message *mp;
#line 474
			
#line 474
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 474
			env_throw_bi(env, mfe_range, "message_read_body_line", _("invalid message descriptor"))
#line 474
;
#line 474
	mp = mtab + nmsg;
#line 474
		if (!(mp->msg))
#line 474
			env_throw_bi(env, mfe_failure, "message_read_body_line", _("message not open"))
#line 474

#line 474
;
#line 474
	if (!mp->body) {
#line 474
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 474
			if (!(rc == 0))
#line 474
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 474
;
#line 474
	}	  
#line 474
;
	
	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 478
			env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 481
;
	}
	rc = mu_stream_getline(mp->bstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 484
			env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 487
;
		if (!(size > 0))
#line 488
			env_throw_bi(env, mfe_eof, "message_read_body_line", "mu_stream_getline: %s",_("end of input"))
#line 491
;
	do {pushs(env, mp->buf);
#line 492
return;
#line 492
} while (0);
}
}


#line 496
void
#line 496
msg_init_builtin()
#line 496
{
#line 496
	
#line 496
	#line 56 "msg.bi"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs,
#line 56
drop_current_message);
#line 165 "msg.bi"
va_builtin_install_ex("message_close", bi_message_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 173 "msg.bi"
va_builtin_install_ex("message_size", bi_message_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 191 "msg.bi"
va_builtin_install_ex("message_lines", bi_message_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 207 "msg.bi"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 225 "msg.bi"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 244 "msg.bi"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 262 "msg.bi"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 278 "msg.bi"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 309 "msg.bi"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, dtype_number, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 322 "msg.bi"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, dtype_string, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 339 "msg.bi"
va_builtin_install_ex("message_nth_header_name", bi_message_nth_header_name, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 355 "msg.bi"
va_builtin_install_ex("message_nth_header_value", bi_message_nth_header_value, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 374 "msg.bi"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 389 "msg.bi"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 404 "msg.bi"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 427 "msg.bi"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 435 "msg.bi"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 462 "msg.bi"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 470 "msg.bi"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, dtype_string, 1, 0, 0|0, dtype_number);

#line 496 "msg.bi"
	
#line 496
	 mf_add_runtime_params(msg_cfg_param);
#line 496
	 
#line 496
}
#line 496 "msg.bi"

#line 498

#line 654 "../../src/builtin/snarf.m4"

#line 654

